#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, m, s;
vector<bool> usedi, usedj;
vector<pair<int, int>> op;
vector<vector<int>> v;
vector<int> smi;

set<int> fi, fj;

void recj(int j);

int cur_sum = 0;

void reci(int i) {
    if (cur_sum < s) return;
    if (i == n) {
        recj(0);
        return;
    }
    fi.erase(i);
    cur_sum -= smi[i];
    usedi[i] = true;
    reci(i + 1);
    usedi[i] = false;
    fi.insert(i);
    cur_sum += smi[i];
    reci(i + 1);
}

void recj(int j) {
    if (j == m) {
        int sm = 0;
        for (auto i : fi) {
            for (auto j : fj) {
                sm += v[i][j];
            }
        }
        if (sm == s) {
            cout << "YES\n";
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                if (usedi[i]) {
                    cnt++;
                }
            }
            for (int j = 0; j < m; j++) {
                if (usedj[j]) {
                    cnt++;
                }
            }
            cout << cnt << endl;
            for (int i = 0; i < n; i++) {
                if (usedi[i]) {
                    cout << 1 << ' ' << i + 1 << endl;
                }
            }
            for (int j = 0; j < m; j++) {
                if (usedj[j]) {
                    cout << 2 << ' ' << j + 1 << endl;
                }
            }
            exit(0);
        }
        return;
    }
    fj.erase(j);
    usedj[j] = true;
    recj(j + 1);
    usedj[j] = false;
    fj.insert(j);
    recj(j + 1);
}

void rec(int sum) {
    if (sum == s) {
        cout << "YES\n";
        cout << op.size() << endl;
        for (auto [t, i]: op) {
            cout << t << ' ' << i + 1 << endl;
        }
        exit(0);
    }
    if (sum < s || sum == 0) return;
    for (int i = 0; i < n; i++) {
        if (!usedi[i]) {
            int sm = 0;
            for (int j = 0; j < m; j++) {
                if (!usedj[j]) {
                    sm += v[i][j];
                }
            }
            op.emplace_back(1, i);
            usedi[i] = true;
            rec(sum - sm);
            op.pop_back();
            usedi[i] = false;
        }
    }
    for (int j = 0; j < m; j++) {
        if (!usedj[j]) {
            int sm = 0;
            for (int i = 0; i < n; i++) {
                if (!usedi[i]) {
                    sm += v[i][j];
                }
            }
            op.emplace_back(2, j);
            usedj[j] = true;
            rec(sum - sm);
            op.pop_back();
            usedj[j] = false;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    usedi.resize(n);
    usedj.resize(m);
    smi.resize(n);
    v.resize(n, vector<int>(m));
    bool flag = true;
    int sm = 0;
    for (int i = 0; i < n; i++) fi.insert(i);
    for (int j = 0; j < m; j++) fj.insert(j);
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
            sum += v[i][j];
            sm += v[i][j];
        }
        smi[i] = sum;
        flag &= (sum <= i + 1);
    }
    cin >> s;
    if (flag) {
        if (sm == s) {
            cout << "YES\n";
            cout << 0;
            return 0;
        }
        rec(sm);
        cout << "NO";
        return 0;
    }
    cur_sum = sm;
    reci(0);
    cout << "NO";
}