#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, m, s;
vector<pair<int, int>> op;
vector<bool> usedi, usedj;
vector<vector<int>> v;

void rec(int sum) {
    if (sum == s) {
        cout << "YES\n";
        cout << op.size() << endl;
        for (auto [t, i] : op) {
            cout << t << ' ' << i + 1 << endl;
        }
        exit(0);
    }
    if (sum < s || sum == 0) return;
    for (int i = 0; i < n; i++) {
        if (!usedi[i]) {
            int sm = 0;
            for (int j = 0; j < m; j++) {
                if (!usedj[j]) {
                    sm += v[i][j];
                }
            }
            op.emplace_back(1, i);
            usedi[i] = true;
            rec(sum - sm);
            op.pop_back();
            usedi[i] = false;
        }
    }
    for (int j = 0; j < m; j++) {
        if (!usedj[j]) {
            int sm = 0;
            for (int i = 0; i < n; i++) {
                if (!usedi[i]) {
                    sm += v[i][j];
                }
            }
            op.emplace_back(2, j);
            usedj[j] = true;
            rec(sum - sm);
            op.pop_back();
            usedj[j] = false;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    usedi.resize(n);
    usedj.resize(m);
    v.resize(n, vector<int>(m));
    int sm = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
            sm += v[i][j];
        }
    }
    cin >> s;
    if (sm == s) {
        cout << "YES\n";
        cout << 0;
        return 0;
    }
    rec(sm);
    cout << "NO";
}
