#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, k, t;
vector<int> dist;
vector<vector<int>> g;

void dfs(int u, int p = -1) {
    for (auto v: g[u]) {
        if (v == p) continue;
        dist[v] = dist[u] + 1;
        dfs(v, u);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> t;
    g.resize(n + 1);
    dist.resize(n + 1, 0);

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    cout << n / 2 - k + 1;
}

/*

8 5 0
1 2
1 3
2 4
2 5
2 6
3 7
3 8

 */