#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, k, t;
vector<int> dist;
vector<vector<int>> g;

void dfs(int u, int p = -1) {
    for (auto v: g[u]) {
        if (v == p) continue;
        dist[v] = dist[u] + 1;
        dfs(v, u);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> t;
    g.resize(n + 1);
    dist.resize(n + 1, 0);
    vector<vector<bool>> used(n + 1, vector<bool> (n + 1, false));

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        used[u][v] = true;
        used[v][u] = true;
        used[i + 1][i + 1] = true;
    }
    int ans = 1e9;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (!used[i][j]) {
                g[i].push_back(j);
                dfs(0);
                sort(all(dist));
                ans = min(ans, dist.back());
                g[i].pop_back();
            }
        }
    }
    cout << ans;
}

/*

8 5 0
1 2
1 3
2 4
2 5
2 6
3 7
3 8

 */