#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, k, t;
vector<int> dist;
vector<vector<int>> g;

void dfs(int u, int p = -1) {
    for (auto v: g[u]) {
        if (v == p) continue;
        dist[v] = dist[u] + 1;
        dfs(v, u);
    }
}
vector<int> dp;
int dfsdp(int u, int p = - 1) {
    if (g[u].size() == 0) {
        return dist[u];
    }
    for (int v : g[u]) {
        if (v == p) continue;
        dp[u] = max(dp[u], dfsdp(v, u));
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> t;
    g.resize(n + 1);
    dist.resize(n + 1, 0);
    vector<vector<bool>> used(n + 1, vector<bool> (n + 1, false));

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        used[u][v] = true;
        used[v][u] = true;
        used[i + 1][i + 1] = true;
    }
    dp.resize(n + 1);
    dfs(0);
    dfsdp(0);
    int ans = 1e9;
    for (int i = 1; i <= n; i++) ans = min(ans, dp[i]);
    for (int i = 2; i <= n; i++) {
        if (used[1][i]) continue;
        int cur_ans = 1e9;
        g[0].push_back(i);
        dfs(0);
        for (int j = 1; j <= n; j++) {
            cur_ans = min(cur_ans, dp[j]);
        }
        ans = min(ans, cur_ans);
    }
    cout << ans;
}

/*

8 5 0
1 2
1 3
2 4
2 5
2 6
3 7
3 8

 */