#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int n, k, t;
vector<int> dist;
vector<vector<int>> g;

void dfs(int u, int p = -1) {
    for (auto v: g[u]) {
        if (v == p) continue;
        dist[v] = dist[u] + 1;
        dfs(v, u);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> t;
    g.resize(n);
    dist.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    if (t == 0) {
        dfs(0);
        sort(all(dist));
        for (int i = n - 1; i >= 0 && k > 0; i--) {
            dist[i] = 1;
            k--;
        }
        sort(all(dist));
        cout << dist.back();
        return 0;
    }
    for (int root = 0; root < n; root++) {
        dfs(root);
        sort(all(dist));
        for (int i = n - 1; i >= 0 && k > 0; i--) {
            dist[i] = 1;
            k--;
        }
        sort(all(dist));
        cout << dist.back() << ' ';
        dist.assign(n, 0);
    }
}

/*

8 5 0
1 2
1 3
2 4
2 5
2 6
3 7
3 8

 */