#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

struct st {
    int vl, ind;
};

bool comp(st a, st b) {
    return a.vl < b.vl;
}

signed main() {
    int n;
    cin >> n;
    vector<st> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].vl;
        v[i].ind = i;
    }
    vector<bool> pr(1e6 + 1, true);
    for (int i = 2; i <= 1e6 + 1; i++) {
        if (pr[i]) {
            for (int j = i * i; j <= 1e6 + 1; j += i) {
                pr[j] = false;
            }
        }
    }
    sort(all(v), comp);
    pr[1] = false;
    vector<int> color(n);
    color[v[0].ind] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (pr[v[j].vl / v[i].vl]) {
                color[v[j].ind] = 3 - color[v[i].ind];
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << color[i] << ' ';
    }
}
