#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

signed main() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        v[i].second = i;
    }
    vector<bool> pr(1e6 + 100, true);
    for (int i = 2; i <= (int) (1e6 + 1); i++) {
        if (pr[i]) {
            for (int j = 2 * i; j <= (int) (1e6 + 1); j += i) {
                pr[j] = false;
            }
        }
    }
    pr[0] = false;
    pr[1] = false;
    sort(all(v));
    vector<int> color(n);
    color[v[0].second] = 1;
    map<int, int> mp;
    mp[v[0].first] = 1;
    for (int i = 1; i < n; i++) {
        if (v[i].first == v[i - 1].first) {
            color[v[i].second] = color[v[i - 1].second];
            continue;
        }
        for (int d = 1; d <= (int) sqrt(v[i].first); d++) {
            if (v[i].first % d != 0) continue;
            if (pr[d] && mp[v[i].first / d] != 0) {
                color[v[i].second] = 3 - mp[v[i].first / d];
                mp[v[i].first] = color[v[i].second];
                break;
            }
            if (pr[v[i].first / d] && mp[d] != 0) {
                color[v[i].second] = 3 - mp[d];
                mp[v[i].first] = color[v[i].second];
                break;
            }
        }
        if (color[v[i].second] == 0) {
            color[v[i].second] = 1;
            mp[v[i].first] = 1;
        }
    }
    for (auto e: color) cout << e << ' ';
    return 0;
}